<script lang="ts" setup>
import { nextTick, onMounted, ref } from "vue";
import type { VForm } from "vuetify/components";
import type { User } from "@/types/User";
import { useUserStore } from "@/stores/user";
import { useRoleStore } from "@/stores/role";
const userStore = useUserStore();
const headers = [
  {
    title: "Id",
    key: "id",
    value: "id",
  },
  {
    title: "Photo",
    key: "image",
  },
  {
    title: "Email",
    key: "email",
    value: "email",
  },
  {
    title: "Full Name",
    key: "fullName",
    value: "fullName",
  },
  {
    title: "Gender",
    key: "gender",
    value: "gender",
  },
  {
    title: "Roles",
    key: "roles",
    value: (item: any | User) => item.roles.map((r: any) => r.name).join(", "),
  },
  { title: "Actions", key: "actions", sortable: false },
];

const roleStore = useRoleStore();
const form = ref(false);
const refForm = ref<VForm | null>(null);
const dialog = ref(false);
const dialogDelete = ref(false);
const loading = ref(false);


function onSubmit() { }

function closeDelete() {
  dialogDelete.value = false;
  nextTick(() => {
    userStore.clearForm();
  });
}
async function deleteItemConfirm() {
  // Delete item from list
  await userStore.deleteUser();
  closeDelete();
}
async function editItem(item: User) {
  if (!item.id) return;
  await userStore.getUser(item.id);
  dialog.value = true;
}
async function deleteItem(item: User) {
  if (!item.id) return;
  await userStore.getUser(item.id);
  dialogDelete.value = true;
}

function closeDialog() {
  dialog.value = false;
  nextTick(() => {
    userStore.clearForm();
  });
}
async function save() {
  const { valid } = await refForm.value!.validate();
  if (!valid) return;
  await userStore.saveUser();
  closeDialog();
}

onMounted(async () => {
  await userStore.getUsers();
  await roleStore.getRoles();
});
</script>

<template>
  <div>
    <v-data-table :headers="headers" :items="userStore.users">
      <template v-slot:top>
        <v-toolbar flat>
          <v-toolbar-title>Users</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!-- Put Edited Dialog -->

          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn color="primary" v-bind="props"> New User </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">User Profile</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field v-model="userStore.editedUser.email" :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                          label="Email"></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field v-model="userStore.editedUser.fullName" :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                          label="Full Name"></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field v-model="userStore.editedUser.password" :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']" clearable label="Password"
                          placeholder="Enter your password"></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="6">
                        <v-combobox label="Gender" :items="['male', 'female', 'others']"
                          v-model="userStore.editedUser.gender"></v-combobox>
                      </v-col>
                      <v-col cols="12" sm="6">
                        <v-combobox v-model="userStore.editedUser.roles" :items="roleStore.roles" item-title="name"
                          item-value="id" label="Select roles" multiple :return-object="true"></v-combobox>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                          <v-img
                            :src="'http://localhost:3000/images/users/' + userStore.editedUser.image"
                            width="200">
                          </v-img>
                        </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-file-input 
                        v-model="userStore.editedUser.files"
                        :rules="[
                          (value) => {
                            return (
                              !value ||
                              !value.length ||
                              value[0].size < 2000000 ||
                              'Avatar size should be less than 2 MB!'
                            );
                          },
                        ]" accept="image/png, image/jpeg" placeholder="Pick an avatar" prepend-icon="mdi-camera"
                          label="Avatar"></v-file-input>
                      </v-col>
                      
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()">
                  Close
                </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <!-- Delete Dialog-->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>

      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
        <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>

      <template v-slot:[`item.image`]="{ item }">
        <v-img :src="'http://localhost:3000/images/users/' + item.image" width="100">
        </v-img>
      </template>

      <template v-slot:no-data>
        <v-btn color="primary" @click="userStore.getUsers"> Reset </v-btn>
      </template>
    </v-data-table>
  </div>
</template>
